/*###########################################################################
#                                                                           #
#                		   ԊO䃂W[      	                    #
#                            Timer01gp                                #
###########################################################################*/
#define __IR_C__
#include "project.h"

/* ԊOLA}N			*/
#define IR_ON()  TCCR0A = ( _BV(COM0A0) | _BV(WGM01) )
#define IR_OFF() { TCCR0A = 0; PORTD &= ~_BV(PD6); }

/* ԊOM|[g					*/
#define IR_IN ( PINB & _BV(PB0) )

/* e萔`						*/
#define IR_STOP_L_MIN 5000				/* XgbvpXLo(us)						*/
#define IR_DATA_DUTY_THRESHOLD 35		/* f[^pXf[eB臒l(35%) ȉȂ1	*/

/* VXeNbN64̃JEgl1JEgӂ̃ʕb (12.8MHz = 5usec) */
#define USEC_PAR_COUNT ( (uint16_t)( ( 1000000UL / ( (uint32_t)F_CPU / 64UL ) ) ) )

/* ʕbVXeNbN64̃JEglɕϊ								 */
#define USEC2COUNT(t) ( (uint16_t)((uint16_t)(t) / USEC_PAR_COUNT ) )

/* VXeNbN64̃JEglʕbɕϊ	*/
#define COUNT2USEC(c) ( (uint16_t)(c) * USEC_PAR_COUNT )

/* Timer1 TCCR1B ݒl				*/
#define EDGE_HI  ( _BV(ICES1) | 0x03 )	/* F_CPU / 64 : ICP1オߊl	*/
#define EDGE_LOW ( 0x03 )				/* F_CPU / 64 : ICP1ߊl	*/

/* [J֐vg^Cv錾		*/
static uint8_t comper_value( uint16_t v1 ,uint16_t v2 ,uint8_t g );
static uint16_t waitEdgeICP1( uint8_t e );

/*****************************************************************************
*							ԊOW[
* Fuint16_t freq LAg
* ߒlFvoid
*****************************************************************************/
void ir_init( uint16_t freq )
{
	/* Timer0(8Bit)ݒ : LAo͗p		*/
	TCCR0A = 0;
	TCCR0B = _BV(CS00);
	OCR0A = (uint16_t)( ( (uint32_t)F_CPU / (uint32_t)freq / 2L ) ) - 1;
	TCNT0 = 0;

	/* Timer1(16Bit)ݒ : Q[gԑp		*/
	TCCR1A = 0;
	TCCR1B = 0;
	TCNT1 = 0;
}

/*****************************************************************************
*									IRf[^o
* FIR   *ir f[^i[\
* ߒlFvoid
*****************************************************************************/
void ir_output( IR *ir )
{
	if ( ir->bitLength == 0 ) {
		return;
	}

	/* JE^							*/
	TCNT1 = 0;
	OCR1A = ir->Start_Htime;
	TIFR1 = _BV(OCF1A);

	/* X^[gpXo						*/
	IR_ON();
	TCCR1B = EDGE_LOW;
	while ( !( TIFR1 & _BV(OCF1A) ) );

	IR_OFF();
	OCR1A += ir->Start_Ltime;
	TIFR1 = _BV(OCF1A);
	while ( !( TIFR1 & _BV(OCF1A) ) );

	/* f[^rbgo							*/
	for ( uint8_t i = 0 ;i < ir->bitLength ;i++ ) {
		IR_ON();
		if ( ir->datas[ i / 8 ] & _BV( 7 - ( i % 8 ) ) ) {
			OCR1A += ir->Dat1_Htime;
			TIFR1 = _BV(OCF1A);
			while ( !( TIFR1 & _BV(OCF1A) ) );
			IR_OFF();
			OCR1A += ir->Dat1_Ltime;
		} else {
			OCR1A += ir->Dat0_Htime;
			TIFR1 = _BV(OCF1A);
			while ( !( TIFR1 & _BV(OCF1A) ) );
			IR_OFF();
			OCR1A += ir->Dat0_Ltime;
		}
		TIFR1 = _BV(OCF1A);
		while ( !( TIFR1 & _BV(OCF1A) ) );
	}

	/* GhpXo							*/
	IR_ON();
	OCR1A += ir->Stop_Htime;
	TIFR1 = _BV(OCF1A);
	while ( !( TIFR1 & _BV(OCF1A) ) );
	IR_OFF();
	for ( uint16_t i = 0 ;i < 1000 ;i++ ) _delay_ms( 0.1 );

	TCCR1B = 0;
}

/*****************************************************************************
*							IRf[^荞
* FIR      *ir 荞݃f[^i[\
* ߒlFuint8_t     0:OK !0:NG
*****************************************************************************/
uint8_t ir_input( IR *ir )
{
	uint16_t h ,l;
	uint16_t backTime;
	uint16_t time;
	uint32_t sum0H = 0 ,sum0L = 0;
	uint32_t sum1H = 0 ,sum1L = 0;
	uint8_t cnt0 = 0 ,cnt1 = 0;
	uint8_t duty;

	/* IR\̃NA						*/
	memset( ir ,0x00 ,sizeof(IR) );

	/* Ԍvp^C}[P			*/
	TCCR1B = 0;
	TCNT1 = 0;
	TIFR1 = _BV(TOV1);

	/* ׂẴL[܂ő҂		*/
	while ( keysNowKeyNumber() != KEY_NOTHING ) {
		wdt_reset();
	}

	/* IR͂LowɂȂ܂ő҂			*/
	while ( IR_IN ) {
		wdt_reset();
		if ( keysNowKeyNumber() == KEY_CANCEL ) {		/* [U[LZH		*/
			return ( 1 );
		}
	}

	/* X^[gpXij҂			*/
	while ( !IR_IN ) {
		wdt_reset();
		if ( keysNowKeyNumber() == KEY_CANCEL ) {		/* [U[LZH		*/
			return ( 1 );
		}
	}

	/* X^[gpXiHI->LOWjԑ	*/
	time = waitEdgeICP1( EDGE_LOW );
	if ( time == 0xffff ) {								/* Time out ?				*/
		return ( 2 );
	}
	ir->Start_Htime = time;
	backTime = time;

	/* X^[gpXiLOW->HIjԑ	*/
	time = waitEdgeICP1( EDGE_HI );
	if ( time == 0xffff ) {								/* Time out ?				*/
		return ( 2 );
	}
	ir->Start_Ltime = time - backTime;
	backTime = time;

	/* f[^pX荞					*/
	while ( 1 ) {

		/* f[^pXiHI->LOWjԑ	*/
		time = waitEdgeICP1( EDGE_LOW );
		if ( time == 0xffff ) {							/* Time out ?				*/
			return ( 2 );
		}
		h = time - backTime;
		backTime = time;

		/* f[^pXiLOW->HIjԑ	*/
		time = waitEdgeICP1( EDGE_HI );
		l = time - backTime;
		backTime = time;

		/* Xgbvf[^M̏		*/
		if ( ( time == 0xffff ) || ( l > USEC2COUNT(IR_STOP_L_MIN) ) ) {
			ir->Stop_Htime = h;
			break;

		/* f[^rbgM̏			*/
		} else {
			if ( ir->bitLength >= ( sizeof( ir->datas ) * 8 ) ) {	/* rbg? */
				return ( 3 );
			}

			duty = (uint8_t)( ( (uint32_t)h * 100UL ) / (uint32_t)( h + l ) );
			if ( duty <= IR_DATA_DUTY_THRESHOLD ) {
				sum1L += (uint32_t)l;
				sum1H += (uint32_t)h;
				cnt1++;
				ir->datas[ ir->bitLength / 8 ] |= _BV( 7 - ( ir->bitLength % 8 ) );
			} else {
				sum0L += (uint32_t)l;
				sum0H += (uint32_t)h;
				cnt0++;
			}
			ir->bitLength++;
		}
	}

	/* Timer1~							*/
	TCCR1B = 0;

	/* f[^rbg\ݒ					*/
	if ( cnt0 ) {
		ir->Dat0_Ltime = (uint16_t)( sum0L / (uint32_t)cnt0 );
		ir->Dat0_Htime = (uint16_t)( sum0H / (uint32_t)cnt0 );
	}

	if ( cnt1 ) {
		ir->Dat1_Ltime = (uint16_t)( sum1L / (uint32_t)cnt1 );
		ir->Dat1_Htime = (uint16_t)( sum1H / (uint32_t)cnt1 );
	}

	/* f[^rbg`FbN				*/
	if ( ir->bitLength < 8 ) {
		return ( 3 );
	}

	/* X^[gpX(SL)`FbN			*/
	if ( COUNT2USEC(ir->Start_Ltime) <= 250 ) {						/* 0.25msecȉH	*/
		return ( 4 );
	}

	if ( COUNT2USEC(ir->Start_Ltime) >= 10000 ) {					/* 10msecȏH		*/
		return ( 4 );
	}

	/* X^[gpX(SH)`FbN			*/
	if ( COUNT2USEC(ir->Start_Htime) <= 250 ) {						/* 0.25msecȉH	*/
		return ( 5 );
	}

	if ( COUNT2USEC(ir->Start_Htime) >= 10000) {					/* 10msecȏH		*/
		return ( 5 );
	}

	/* f[^rbgpX(0L)`FbN		*/
	if ( COUNT2USEC(ir->Dat0_Ltime) <= 100 ) {						/* 100secȉH	*/
		return ( 6 );
	}

	if ( COUNT2USEC(ir->Dat0_Ltime) >= 4000 ) {						/* 4000secȏH	*/
		return ( 6 );
	}

	/* f[^rbgpX(0H)`FbN		*/
	if ( COUNT2USEC(ir->Dat0_Htime) <= 100 ) {						/* 100secȉH	*/
		return ( 7 );
	}

	if ( COUNT2USEC(ir->Dat0_Htime) >= 2000 ) {						/* 2000secȏH	*/
		return ( 7 );
	}

	/* f[^rbgpX(1L)`FbN		*/
	if ( COUNT2USEC(ir->Dat1_Ltime) <= 100 ) {						/* 100secȉH	*/
		return ( 8 );
	}

	if ( COUNT2USEC(ir->Dat1_Ltime) >= 2000 ) {						/* 2000secȏH	*/
		return ( 8 );
	}

	/* f[^rbgpX(1H)`FbN		*/
	if ( COUNT2USEC(ir->Dat1_Htime) <= 100 ) {						/* 100secȉH	*/
		return ( 9 );
	}

	if ( COUNT2USEC(ir->Dat1_Htime) >= 2000 ) {						/* 2000secȏH	*/
		return ( 9 );
	}

	/* Xgbv(Gh)pX(EH)`FbN	*/
	if ( COUNT2USEC(ir->Stop_Htime) <= 250 ) {						/* 0.25msecȉH	*/
		return ( 10 );
	}

	if ( COUNT2USEC(ir->Stop_Htime) >= 10000 ) {					/* 10msecȏH		*/
		return ( 10 );
	}

	return ( 0 );
}

/*****************************************************************************
*							IRf[^\̔r
*	Fstruct irdata_s *ip1 irdata_s\̂ւ̃|C^
*	      struct irdata_s *ip2 irdata_s\̂ւ̃|C^
*	ߒlFuint8_t              0:v !0:sv
*****************************************************************************/
uint8_t ir_comper( IR *ir1 ,IR *ir2 )
{
	uint8_t i;
	uint8_t bytes;

	/* X^[gpXLOWxԔr(덷70usec܂ŋe)	*/
	if ( comper_value( COUNT2USEC(ir1->Start_Ltime) ,COUNT2USEC(ir2->Start_Ltime) ,70 ) != 0 ) {
		return ( 1 );
	}

	/* X^[gpXHIxԔr(덷70usec܂ŋe)	*/
	if ( comper_value( COUNT2USEC(ir1->Start_Htime) ,COUNT2USEC(ir2->Start_Htime) ,70 ) != 0 ) {
		return ( 2 );
	}

	/* f[^OpXLOWxԔr(덷30usec܂ŋe)	*/
	if ( comper_value( COUNT2USEC(ir1->Dat0_Ltime) ,COUNT2USEC(ir2->Dat0_Ltime) ,30 ) != 0 ) {
		return ( 3 );
	}

	/* f[^OpXHIxԔr(덷30usec܂ŋe)		*/
	if ( comper_value( COUNT2USEC(ir1->Dat0_Htime) ,COUNT2USEC(ir2->Dat0_Htime) ,30 ) != 0) {
		return ( 4 );
	}

	/* f[^PpXLOWxԔr(덷30usec܂ŋe)	*/
	if ( comper_value( COUNT2USEC(ir1->Dat1_Ltime) ,COUNT2USEC(ir2->Dat1_Ltime) ,30 ) != 0 ) {
		return ( 5 );
	}

	/* f[^PpXHIxԔr(덷30usec܂ŋe)		*/
	if ( comper_value( COUNT2USEC(ir1->Dat1_Htime) ,COUNT2USEC(ir2->Dat1_Htime) ,30 ) != 0 ) {
		return ( 6 );
	}

	/* XgbvpXHIxԔr(덷70usec܂ŋe)		*/
	if ( comper_value( COUNT2USEC(ir1->Stop_Htime) ,COUNT2USEC(ir2->Stop_Htime) ,70 ) != 0 ) {
		return ( 7 );
	}

	/* rbgriSrj							*/
	if ( ir1->bitLength != ir2->bitLength ) {
		return ( 8 );
	}

	/* f[^riSrj							*/
	bytes = ( ir1->bitLength + 7 ) / 8;
	for ( i = 0 ;i < bytes ;i++ ) {
		if ( ir1->datas[i] != ir2->datas[i] ) {
			return ( 100 + i );
		}
	}

	return ( 0 );
}

/*****************************************************************************
*							Q̒lr
* Fuint16_t v1 l1
*       uint16_t v2 l2
*       uint8_t  g  덷
* ߒlFuint8_t     0 : v
*				   !0 : sv
*****************************************************************************/
static uint8_t comper_value( uint16_t v1 ,uint16_t v2 ,uint8_t g )
{
	uint16_t a;

	/* 2̒l̍̐ΒlvZ			*/
	if ( v1 > v2 ) {
		a = v1 - v2;
	} else {
		a = v2 - v1;
	}

	/* 덷`FbN							*/
	if ( a > g ) {
		return ( 1 );
	}

	return ( 0 );
}

/*****************************************************************************
*							ICP1̃GbWo
* Fuint8_t e EDGE_HI / EDGE_LOW
* ߒlFuint16_t  JE^l(0xffff:timeout)
*****************************************************************************/
static uint16_t waitEdgeICP1( uint8_t e )
{
	TCCR1B = e;
	TIFR1 |= _BV(ICF1);
	while ( !( TIFR1 & _BV(ICF1) ) ) {
		if ( TIFR1 & _BV(TOV1) ) {						/* Time out ?		*/
			return ( 0xffff );
		}
	}
	return ( ICR1 );
}
