/*###########################################################################
#                                                                           #
#    		          GARpԊOwKR^C}[					#
#                                                                           #
###########################################################################*/
#define __MAIN_C__
#include "project.h"

/*****************************************************************************
*								n[hEGA
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void hardwareInit( void )
{
	/*  PortB +--------7: Pullup : PushSW(RIGHT or CANCEL)                      */
	/*        |+-------6: ------ : XTAL(12.8MHz)                                */
	/*        ||+------5: Out(H) : LCD Read / #Write                            */
	/*        |||+-----4: Out(H) : LCD Data / #Instruction                      */
	/*        ||||+----3: Out(L) : LCD E                                        */
	/*        |||||+---2: Out(L) : LCD CS1                                      */
	/*        ||||||+--1: Out(L) : LCD CS2                                      */
	/*        |||||||+-0: HI-Z   : IR-IN                                        */
	DDRB  = 0b00111110;
	PORTB = 0b10110000;

	/*  PortC +--------7: ------ :                                              */
	/*        |+-------6: ------ : #RESET                                       */
	/*        ||+------5: Pullup : #DC-IN                                       */
	/*        |||+-----4: Pullup : PushSW(DOWN or ENTER)                        */
	/*        ||||+----3: HI-Z   : LCD DB7                                      */
	/*        |||||+---2: HI-Z   : LCD DB6                                      */
	/*        ||||||+--1: HI-Z   : LCD DB5                                      */
	/*        |||||||+-0: HI-Z   : LCD DB4                                      */
	DDRC  = 0b00000000;
	PORTC = 0b00110000;

	/*  PortD +--------7: Pullup : PushSW(UP or ENTER)                          */
	/*        |+-------6: Out(L) : IR-OUT                                       */
	/*        ||+------5: Pullup : PushSW(LEFT or CANCEL)                       */
	/*        |||+-----4: Out(L) : LCD #RESET                                   */
	/*        ||||+----3: HI-Z   : LCD DB3                                      */
	/*        |||||+---2: HI-Z   : LCD DB2                                      */
	/*        ||||||+--1: HI-Z   : LCD DB1                                      */
	/*        |||||||+-0: HI-Z   : LCD DB0                                      */
	DDRD  = 0b01010000;
	PORTD = 0b10100000;

	/* EIb`hbNݒ				*/
	wdt_enable( WDTO_4S );

	/* ԊOW[			*/
	ir_init( 38000 );

	/* LCDW[				*/
	LCD_init();

	/* RTC						*/
	RTC_init();

	/* KEYW[				*/
	keysInit();
}

/*****************************************************************************
*						C֐
*****************************************************************************/
int main( void )
{
	uint8_t screen = 3;

	/* 							*/
	hardwareInit();
	sei();

	/* EEP`FbN						*/
	if ( ( eep_check() != 0 ) || ( keysNowKeyNumber() == KEY_CANCEL ) ) {
		LCD_clr();
		LCD_Gputs_P( 4 ,30 ,PSTR("EEPROM formating ...") );
		eep_format();
		if ( eep_check() != 0 ) {
			LCD_Gputs_P( 68 ,38 ,PSTR("Failure !!") );
			LCD_invertRect( 66 ,37 ,127 ,45 );
			while ( 1 ) wdt_reset();
		}
	}

	/* ʕ\						*/
	LCD_clr();
	LCD_drawBMP( img001 ,7 ,0 ,114 ,9 );		/* "ԊOwKR^C}["	*/
	LCD_Gputs_P( 128 - ( strlen_P( version ) * 6 ) ,10 ,version );
	LCD_Gputs_P( 86 ,18 ,PSTR("by nPYO") );
	LCD_drawBMP( img002 ,8 ,54 ,111 ,9 );		/* "Enter𒷉ĉ"	*/

	/* L[҂							*/
	keysClear();
	while ( 1 ) {
		while ( !RTC_TICK_MS10 );
		RTC_TICK_MS10 = 0;
		wdt_reset();
		keysWatchKey();							/* L[|[O				*/
		if ( keysInkey() == ( KEY_LONGPUSH_START | KEY_ENTER ) ) {
			break;
		}
	}

	/* ݒ							*/
	tickSec = 1;
	RTC_init();

	/* eʏ						*/
	while ( 1 ) {
		wdt_reset();
		switch ( screen ) {
			case 0:							/* ʏ			*/
				screen = menu001();
				break;

			case 1:							/* j[			*/
				screen = menu002();
				break;

			case 2:							/* ^C}[ݒ		*/
				screen = menu003();
				break;

			case 3:							/* 킹		*/
				screen = menu004();
				break;

			case 4:							/* IRwK			*/
				screen = menu005();
				break;

			default:
				screen = 0;
				break;
		}
	}

	return ( 0 );
}
