/*###########################################################################
#                															#
#   			              ^C}[vO						#
#                                                            				#
###########################################################################*/
#define __PROGTIME_C__
#include "project.h"

/* O[oϐ錾			*/
extern uint8_t tickSec;
extern uint8_t tickDay;
extern uint8_t pgFlag[];
extern uint32_t backupSerial;

/*****************************************************************************
*						vO^C}[
* Fvoid
* ߒlFvoid
*****************************************************************************/
void progTimerPoll( void )
{
	TIME nowTime;
	TIME bakTime;

	uint32_t nowTimeSerial;
	uint32_t pgTimeSerial;
	uint32_t nowSerial;
	PG pg;
	IR ir;

	/* ݂̎ƎԂ̃VA擾					*/
	nowSerial = RTC_getSerial();
	nowTimeSerial = nowSerial % ( 24L * 60L * 60L );
	RTC_convTime( nowSerial ,&nowTime );

	/* vO^C}[							*/
	for ( uint8_t i = 0 ;i < PG_COUNT ;i++ ) {

		/* vO擾								*/
		eep_pgRead( i ,&pg );

		/* ͉Ȃ							*/
		if ( pg.active == 0 ) {
			continue;
		}

		/* sς݂̏ꍇ͉Ȃ					*/
		if ( pgFlag[i] != 0 ) {
			continue;
		}

		/* TԎw聕jsv̏ꍇ͉Ȃ		*/
		if ( pg.type == 0 ) {
			if ( !( pg.week & _BV(nowTime.wday) ) ) {
				continue;
			}

		/* tw聕tvȂꍇ͉Ȃ	*/
		} else {
			if ( ( pg.year != nowTime.year ) || ( pg.month != nowTime.month ) || ( pg.day != nowTime.day ) ) {	/* tsv̏ꍇ͉Ȃ */
				continue;
			}
		}

		/* v̏								*/
		pgTimeSerial = ( (uint32_t)pg.hour * 3600L ) + ( (uint32_t)pg.minute * 60L );
		if ( pgTimeSerial <= nowTimeSerial ) {

			/* IRo										*/
			eep_irRead( pg.irIndex ,&ir );
			for ( uint8_t j = 0 ;j < IR_LOOP ;j++ ) {
				wdt_reset();
				ir_output( &ir );
				WAIT_MS( 1000 );
			}
			keysClear();

			/* sς݃tOZbg							*/
			pgFlag[i] = 1;
		}
	}

	/* bωtO^tωtO		*/
	if ( nowSerial != backupSerial ) {
		tickSec = 1;
		RTC_convTime( backupSerial ,&bakTime );
		if ( nowTime.day != bakTime.day ) {				/* tςH	*/
			memset( pgFlag ,0x00 ,PG_COUNT );
		}
		backupSerial = nowSerial;
	}
}

/*****************************************************************************
*				݂̎ƃvOstO̐
* Fvoid
* ߒlFvoid
*****************************************************************************/
void progInitExecFlag( void )
{
	TIME nowTime;
	uint32_t nowSerial;
	uint32_t pgSerial;
	PG pg;

	/* ݎ擾					*/
	nowSerial = RTC_getSerial();
	backupSerial = nowSerial;
	RTC_convTime( nowSerial ,&nowTime );
	nowSerial %= ( 24L * 60L * 60L );

	/* evÕtOZbg	*/
	memset( pgFlag ,0x01 ,PG_COUNT );
	for ( uint8_t i = 0 ;i < PG_COUNT ;i++ ) {
		eep_pgRead( i ,&pg );
		if ( pg.active == 0 ) {
			continue;
		}

		if ( pg.type == 0 ) {
			if ( !( pg.week & _BV(nowTime.wday) ) ) {
				continue;
			}
		} else {
			if ( ( pg.year != nowTime.year ) || ( pg.month != nowTime.month ) || ( pg.day != nowTime.day ) ) {
				continue;
			}
		}

		pgSerial = ( (uint32_t)pg.hour * 3600L ) + ( (uint32_t)pg.minute * 60L );
		if ( pgSerial < nowSerial ) {
			continue;
		}

		pgFlag[i] = 0;
	}
}
