/*###########################################################################
#                                                                           #
#                		   VXe֘AW[							#
#                                                                           #
###########################################################################*/
#define __SYSTEM_C__
#include "project.h"

#define ID PSTR("nPYO IR-TIMER  ")			/* EEPʎq(16bytes)	*/

/* ֐vg^Cv錾			*/
static void eep_writeCRC( void );
static uint16_t eep_calcCRC( void );

/*****************************************************************************
*					eepromtH[}bg
* Fvoid
* ߒlFvoid
*****************************************************************************/
void eep_format( void )
{
	EEPMAP *map = 0;
	PG pg;
	IR ir;
	uint16_t i;

	/* ʎq				*/
	wdt_reset();
	memcpy_P( &ir ,ID ,16 );
	eeprom_busy_wait();
	eeprom_write_block( &ir ,&map->id ,16 );

	/* IRf[^NA				*/
	wdt_reset();
	memset( &ir ,0x00 ,sizeof(IR) );
	for ( i = 0 ;i < IR_COUNT ;i++ ) {
		eep_irWrite( i ,&ir );
	}

	/* vOf[^NA		*/
	wdt_reset();
	memset( &pg ,0x00 ,sizeof(PG) );
	pg.year = 2010;
	pg.month = START_MONTH;
	pg.day = START_DAY;
	for ( i = 0 ;i < PG_COUNT ;i++ ) {
		eep_pgWrite( i ,&pg );
	}

	/* _~[f[^NA			*/
	wdt_reset();
	for ( i = 0 ;i < sizeof( map->dumy ) ;i++ ) {
		eeprom_busy_wait();
		eeprom_write_byte( &map->dumy[i] ,0xff );
	}

	/* CRC					*/
	eep_writeCRC();
}

/*****************************************************************************
*					eepromf[^̐mF
* Fvoid
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
uint8_t eep_check( void )
{
	uint8_t buf[16];
	EEPMAP *map = 0;
	uint16_t crc1 ,crc2;

	/* ʎq`FbN			*/
	eeprom_busy_wait();
	eeprom_read_block( buf ,map->id ,sizeof(map->id) );
	if ( memcmp_P( buf ,ID ,sizeof(map->id) ) != 0 ) {
		return ( 1 );
	}

	/* CRC`FbN				*/
	crc1 = eep_calcCRC();
	eeprom_busy_wait();
	eeprom_read_block( &crc2 ,&map->crc ,sizeof(map->crc) );
	if ( crc1 != crc2 ) {
		return ( 2 );
	}

	return ( 0 );
}

/*****************************************************************************
*					eepromvOf[^ǂݍ
* Fuint8_t index PGԍ(0`99)
*       PG      *pg   \̂ւ̃|C^
* ߒlFvoid
*****************************************************************************/
void eep_pgRead( uint8_t index ,PG *pg )
{
	EEPMAP *map = 0;
	eeprom_busy_wait();
	eeprom_read_block( pg ,&map->pg[index] ,sizeof(PG) );
}

/*****************************************************************************
*					eepromփvOf[^
* Fuint8_t index PGԍ(0`99)
*       PG      *pg   \̂ւ̃|C^
* ߒlFvoid
*****************************************************************************/
void eep_pgWrite( uint8_t index ,PG *pg )
{
	EEPMAP *map = 0;
	eeprom_busy_wait();
	eeprom_write_block( pg ,&map->pg[index] ,sizeof(PG) );
	eep_writeCRC();
}

/*****************************************************************************
*					eepromIRf[^ǂݍ
* Fuint8_t index IRԍ(0`7)
*       IR      *ir   \̂ւ̃|C^
* ߒlFvoid
*****************************************************************************/
void eep_irRead( uint8_t index ,IR *ir )
{
	EEPMAP *map = 0;
	eeprom_busy_wait();
	eeprom_read_block( ir ,&map->ir[index] ,sizeof(IR) );
}

/*****************************************************************************
*					eepromIRf[^
* Fuint8_t index IRԍ(0`7)
*       IR      *ir   \̂ւ̃|C^
* ߒlFvoid
*****************************************************************************/
void eep_irWrite( uint8_t index ,IR *ir )
{
	EEPMAP *map = 0;
	eeprom_busy_wait();
	eeprom_write_block( ir ,&map->ir[index] ,sizeof(IR) );
	eep_writeCRC();
}

/*****************************************************************************
*					eepromCRCvZď
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void eep_writeCRC( void )
{
	EEPMAP *map = 0;
	uint16_t crc = eep_calcCRC();
	eeprom_busy_wait();
	eeprom_write_block( &crc ,&map->crc ,sizeof(map->crc) );
}

/*****************************************************************************
*					eepromf[^CRCvZ
* Fvoid
* ߒlFuint16_t CRCl
*****************************************************************************/
static uint16_t eep_calcCRC( void )
{
	EEPMAP *map = 0;
	uint8_t *p = (uint8_t *)&map->crc + sizeof(map->crc);
	uint16_t crc = 0xffff;
	uint16_t len = sizeof( EEPMAP ) - sizeof(map->crc);

	while ( len-- ) {
		eeprom_busy_wait();
		crc = _crc16_update( crc ,eeprom_read_byte( p++ ) );
	}

	crc ^= 0xffff;
	return ( crc );
}
